%define section free

Summary:        High performance J2EE caching solution
Name:           oscache
Version:        2.0.1
Release:        2jpp
Epoch:          0
License:        Apache Software License
URL:            http://www.opensymphony.com/oscache/
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        oscache-2.0.1-full.zip
Source1:        oscache-build.xml
Source2:        oscache-build.properties
Source3:        oscache-jalopy.xml
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  junit
BuildRequires:  ant >= 0:1.5
#BuildRequires:  ant >= 0:1.5.4, ant-optional >= 0:1.5.4
BuildRequires:  clover
BuildRequires:  httpunit
BuildRequires:  jdom
BuildRequires:  jms
BuildRequires:  log4j
BuildRequires:  oro
BuildRequires:  servletapi4
BuildRequires:  junitperf
Requires:  /usr/sbin/update-alternatives
Requires:  jdom
Requires:  jms
Requires:  log4j
Requires:  oro
Requires:  servletapi4
Provides:  hibernate_in_process_cache

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
OSCache solves fundamental problems for dynamic websites:
+ Caching Dynamic Content - Dynamic content must often be 
executed in some form each request, but sometimes that 
content doesn't change every request. Caching the whole 
page does not help because sections of the page change 
every request. OSCache solves this problem by providing 
a means to cache sections of JSP pages. 
+ Caching Binary Content - Generated images and PDFs can 
be very costly in terms of server load. OSCache solves 
this problem through a Servlet 2.3 CachingFilter which 
can cache any URI (such as an entire page or a generated 
image/PDF) 
+ Error Tolerance - If one error occurs somewhere on your 
dynamic page, chances are the whole page will be returned 
as an error, even if 95% of the page executed correctly. 
OSCache solves this problem by allowing you to serve the 
cached content in the event of an error, and then 
reporting the error appropriately. 


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -T -c -n %{name}-%{version}
unzip -q %{SOURCE0}
find . -name "*.jar" -exec rm {} \;
cp %{SOURCE1} build.xml
cp %{SOURCE2} build.properties
mkdir -p src/core/etc
cp %{SOURCE3} src/core/etc/jalopy.xml
cp etc/* src/core/etc

%build
export CLASSPATH=$(build-classpath \
ant \
clover \
httpunit \
jdom \
jms \
log4j \
oro \
servletapi4 \
junitperf \
junit)
(cd lib/core
ln -s $(find-jar commons-collections) commons-collections.jar
ln -s $(find-jar commons-logging) commons-logging.jar
)
(cd lib/plugins/clustersupport
ln -s $(find-jar javagroups) javagroups-all.jar
)
mkdir -p lib/build/jalopy
(cd lib/build/jalopy
ln -s $(find-jar jalopy) jalopy.jar
ln -s $(find-jar jalopy-ant) jalopy-ant.jar
)
ant -Dbuild.sysclasspath=first dist

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p dist/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp etc/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf dist/docs/api

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr dist/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p dist/oscache-example.war $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# hibernate_in_process_cache ghost symlink
ln -s %{_sysconfdir}/alternatives \
  $RPM_BUILD_ROOT%{_javadir}/hibernate_in_process_cache.jar


%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{_javadir}/hibernate_in_process_cache.jar \
  hibernate_in_process_cache %{_javadir}/%{name}.jar 50

%preun
{
  [ $1 -eq 0 ] || exit 0
  update-alternatives --remove hibernate_in_process_cache %{_javadir}/%{name}.jar
} >/dev/null 2>&1 || :

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}
%{_javadir}
%ghost %{_javadir}/hibernate_in_process_cache.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}

%changelog
* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.1-2jpp
- Relax some versioned dependencies
- Provide hibernate_in_process_cache and do update-alternatives, prio 50

* Sat Feb 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.1-1jpp
- First JPackage release
